location 3.0.2

  • Readme
  • Changelog
  • Example
  • Installing
  • 100

Flutter Location Plugin #

pub package Cirrus CI - Task and Script Build Status codecov

This plugin for Flutter handles getting location on Android and iOS. It also provides callbacks when location is changed.

Demo App

Getting Started #

Add this to your package's pubspec.yaml file:

dependencies:
  location: ^3.0.0

Android #

With Flutter 1.12, all the dependencies are automatically added to your project. If your project was created before Flutter 1.12, you may need to follow this.

iOS #

And to use it in iOS, you have to add this permission in Info.plist :

NSLocationWhenInUseUsageDescription
NSLocationAlwaysUsageDescription

Web #

Nothing to do, the plugin works directly out of box.

macOS #

Ensure that the application is properly "sandboxed" and that the location is enabled. You can do this in Xcode with the following steps:

  1. In the project navigator, click on your application's target. This should bring up a view with tabs such as "General", "Capabilities", "Resource Tags", etc.
  2. Click on the "Capabilities" tab. This will give you a list of items such as "App Groups", "App Sandbox" and so on. Each item will have an "On/Off" button.
  3. Turn on the "App Sandbox" item and press the ">" button on the left to show the sandbox stuff.
  4. In the "App Data" section, select "Location".

Add this permission in Info.plist :

NSLocationWhenInUseUsageDescription
NSLocationAlwaysUsageDescription

Usage #

Then you just have to import the package with

import 'package:location/location.dart';

In order to request location, you should always check manually Location Service status and Permission status.

Location location = new Location();

bool _serviceEnabled;
PermissionStatus _permissionGranted;
LocationData _locationData;

_serviceEnabled = await location.serviceEnabled();
if (!_serviceEnabled) {
  _serviceEnabled = await location.requestService();
  if (!_serviceEnabled) {
    return;
  }
}

_permissionGranted = await location.hasPermission();
if (_permissionGranted == PermissionStatus.denied) {
  _permissionGranted = await location.requestPermission();
  if (_permissionGranted != PermissionStatus.granted) {
    return;
  }
}

_locationData = await location.getLocation();

You can also get continuous callbacks when your position is changing:

location.onLocationChanged.listen((LocationData currentLocation) {
  // Use current location
});

Be sure to check the example project to get other code samples.

Public Methods Summary #

ReturnDescription
Future<PermissionStatus>requestPermission()
Request the Location permission. Return a PermissionStatus to know if the permission has been granted.
Future<PermissionStatus>hasPermission()
Return a PermissionStatus to know the state of the location permission.
Future<bool>serviceEnabled()
Return a boolean to know if the Location Service is enabled or if the user manually deactivated it.
Future<bool>requestService()
Show an alert dialog to request the user to activate the Location Service. On iOS, will only display an alert due to Apple Guidelines, the user having to manually go to Settings. Return a boolean to know if the Location Service has been activated (always false on iOS).
Future<bool>changeSettings(LocationAccuracy accuracy = LocationAccuracy.HIGH, int interval = 1000, double distanceFilter = 0)
Will change the settings of futur requests. accuracywill describe the accuracy of the request (see the LocationAccuracy object). interval will set the desired interval for active location updates, in milliseconds (only affects Android). distanceFilter set the minimum displacement between location updates in meters.
Future<LocationData>getLocation()
Allow to get a one time position of the user. It will try to request permission if not granted yet and will throw a PERMISSION_DENIED error code if permission still not granted.
Stream<LocationData>onLocationChanged
Get the stream of the user's location. It will try to request permission if not granted yet and will throw a PERMISSION_DENIED error code if permission still not granted.

You should try to manage permission manually with requestPermission() to avoid error, but plugin will try handle some cases for you.

Objects #

class LocationData {
  final double latitude; // Latitude, in degrees
  final double longitude; // Longitude, in degrees
  final double accuracy; // Estimated horizontal accuracy of this location, radial, in meters
  final double altitude; // In meters above the WGS 84 reference ellipsoid
  final double speed; // In meters/second
  final double speedAccuracy; // In meters/second, always 0 on iOS
  final double heading; //Heading is the horizontal direction of travel of this device, in degrees
  final double time; //timestamp of the LocationData
}


enum LocationAccuracy {
  powerSave, // To request best accuracy possible with zero additional power consumption,
  low, // To request "city" level accuracy
  balanced, // To request "block" level accuracy
  high, // To request the most accurate locations available
  navigation // To request location for navigation usage (affect only iOS)
}

// Status of a permission request to use location services.
enum PermissionStatus {
  /// The permission to use location services has been granted.
  granted,
  // The permission to use location services has been denied by the user. May have been denied forever on iOS.
  denied,
  // The permission to use location services has been denied forever by the user. No dialog will be displayed on permission request.
  deniedForever
}

Note: you can convert the timestamp into a DateTime with: DateTime.fromMillisecondsSinceEpoch(locationData.time.toInt())

Feedback #

Please feel free to give me any feedback helping support this plugin !

[3.0.2] 3rd April 2020 #

  • Improve code coverage
  • Fix a bug when requesting permission using an intent (thanks to kennethj)
  • Fix a bug when onDetachedFromActivity is called (thanks to creativepsyco)

[3.0.1] 27th March 2020 #

  • Fix a crash happening during iOS build

[3.0.0] 26th March 2020 #

  • Add Web and macOS as new supported platforms (huge thanks to long1eu)
  • [BREAKING] Enums are now following Dart guidelines.
  • [BREAKING] onLocationChanged is now a getter to follow Dart guidelines.

[2.5.4] 11st March 2020 #

  • Update documentation
  • Fix: Airplane mode was preventing location from being requested
  • Fix: Not crashing when activity is not set on Android

[2.5.3] 26th February 2020 #

  • Improve code coverage
  • Update documentation

[2.5.2] 25th February 2020 #

  • Fix crash on pre-1.12 projects
  • Align PermissionStatus on iOS with Android

[2.5.1] 23rd February 2020 #

  • Fix SDK version

[2.5.0] 23rd February 2020 #

  • [BREAKING] The requestPermission and hasPermission are now returning PermissionStatus enum.
  • Upgrade to Android Embedding V2 (follow https://github.com/flutter/flutter/wiki/Upgrading-pre-1.12-Android-projects if the plugin isn't working after upgrade)
  • Resolve getLocation when service is disabled thanks to nicowernli
  • Update example app
  • Fix bugs leading to non returning code
  • getLocation now throws properly
  • pub.dev now states that the plugin is not compatible with Flutter Web (yet)

[2.4.0] 14th February 2020 #

  • Align timestamp in Android and iOS, previously the iOS timestamp was in seconds instead of milliseconds. Thanks to 781flyingdutchman.

[2.3.7] 08th January 2020 #

  • Fix bug where requestPermission is called after the user has already denied the system location dialog, then this method call would never return.

[2.3.6] 07th January 2020 #

  • Fix ClassCastException errors on some Android phones when requesting Location status.

[2.3.5] 10th April 2019 #

  • Fix incompatibily with headless plugins thanks to ehhc
  • Fix error with iOS when permission already given
  • Add Google maps example

[2.3.4] 8th April 2019 #

  • Fix error on Android 21 API thanks to noordawod
  • Update Google API version

[2.3.3] 31th March 2019 #

  • Align altitude on Sea Level when available on Android (matching iOS altitude).

[2.3.2] 27th March 2019 #

  • Remove GPS limitation on Android

[2.3.1] 25th March 2019 #

  • Fixes README
  • Fixes requestPermission not responding the correct result on iOS

[2.3.0] 22nd March 2019 #

  • Update example App with proper cancel
  • Add possibility to set accuracy, interval and minimum notification ditance of the requests.
  • Add LocationAccuracy object

[2.2.0] 19th March 2019 #

  • Actually updating locatino when using getLocation (not only relying on LastLocation)
  • Add timestamp to LocationData
  • Add serviceEnabled method to check whether Location Service is enabled.
  • Add requestService method to ask the user to activate the location service.
  • Fix continuous callback heading

[2.1.0] 16th Match 2019 #

  • iOS permission should be closer to Android permission behaviour thanks to PerrchicK
  • Adding requestPermission(), to manually request permission
  • Several feature fixed for less crash when using the plugin
  • Code Cleanup
  • Update Readme and add a warning for the location bug in iOS simulator

[2.0.0] 25th January 2019 #

  • Code cleanup
  • BREAKING CHANGE: Change Dart API to return structured data rather than a map.

[1.4.0] 21st August 2018 #

  • Add lazy permission request thanks to yathit
  • Add hasPermission() thanks to vagrantrobbie
  • Bug correction thanks to jalpedersen
  • Add more examples

[1.3.4] 4th June 2018 #

  • Fix crash for Android API pre 27 thanks to matthewtsmith.

[1.3.3] 30th May 2018 #

  • Correct implementation of iOS plugin to match Android behaviour. No need to call getLocation to get permissions for location callbacks.

[1.3.2] 30th May 2018 #

  • Change implementation to api in build.gradle in order to solve incompatibilities between GMS versions thanks to luccascorrea

[1.3.1] 29th May 2018 #

  • Added speed and speed_accuracy (only Android truly discover speed accuracy, so its always 0 for now on iOS)
  • Solved a crash

[1.3.0] 27th May 2018 #

  • Make it compatible with Firebase thanks to quangIO
  • Resolve runtime error exception thanks to jharrison902
  • Update gitignore thanks to bcko

[1.2.0] 5th April 2018 #

  • Permissions denied on Android handled thanks to g123k
  • Dart 2 update thanks to efortuna

[1.1.6] - 19th Octobre 2017. #

  • iOS code from Swift to Objective-C thanks to fluff

[1.1.1] - 20th July 2017. #

  • Fixes for iOS result's format.

[1.1.0] - 17th July 2017. #

  • Added permission check for Android 6+ (thanks netdur). Still no callback when permissions granted so aiming SDK 21 is safer.

[1.0.0] - 7th July 2017. #

  • Initial Release.

example/lib/main.dart

import 'package:flutter/material.dart';
import 'package:location/location.dart';
import 'package:url_launcher/url_launcher.dart';

import 'get_location.dart';
import 'listen_location.dart';
import 'permission_status.dart';
import 'service_enabled.dart';

void main() => runApp(MyApp());

class MyApp extends StatelessWidget {
  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Flutter Location',
      theme: ThemeData(
        primarySwatch: Colors.amber,
      ),
      home: const MyHomePage(title: 'Flutter Location Demo'),
    );
  }
}

class MyHomePage extends StatefulWidget {
  const MyHomePage({Key key, this.title}) : super(key: key);
  final String title;

  @override
  _MyHomePageState createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  final Location location = Location();

  Future<void> _showInfoDialog() {
    return showDialog<void>(
      context: context,
      builder: (BuildContext context) {
        return AlertDialog(
          title: const Text('Demo Application'),
          content: SingleChildScrollView(
            child: ListBody(
              children: <Widget>[
                const Text('Created by Guillaume Bernos'),
                InkWell(
                  child: Text(
                    'https://github.com/Lyokone/flutterlocation',
                    style: TextStyle(
                      decoration: TextDecoration.underline,
                    ),
                  ),
                  onTap: () =>
                      launch('https://github.com/Lyokone/flutterlocation'),
                ),
              ],
            ),
          ),
          actions: <Widget>[
            FlatButton(
              child: const Text('Ok'),
              onPressed: () {
                Navigator.of(context).pop();
              },
            ),
          ],
        );
      },
    );
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(widget.title),
        actions: <Widget>[
          IconButton(
            icon: Icon(Icons.info_outline),
            onPressed: _showInfoDialog,
          )
        ],
      ),
      body: Container(
        padding: const EdgeInsets.all(32),
        child: Column(
          children: const <Widget>[
            PermissionStatusWidget(),
            Divider(height: 32),
            ServiceEnabledWidget(),
            Divider(height: 32),
            GetLocationWidget(),
            Divider(height: 32),
            ListenLocationWidget()
          ],
        ),
      ),
    );
  }
}

Use this package as a library

1. Depend on it

Add this to your package's pubspec.yaml file:


dependencies:
  location: ^3.0.2

2. Install it

You can install packages from the command line:

with Flutter:


$ flutter pub get

Alternatively, your editor might support flutter pub get. Check the docs for your editor to learn more.

3. Import it

Now in your Dart code, you can use:


import 'package:location/location.dart';
  
Popularity:
Describes how popular the package is relative to other packages. [more]
99
Health:
Code health derived from static analysis. [more]
100
Maintenance:
Reflects how tidy and up-to-date the package is. [more]
100
Overall:
Weighted score of the above. [more]
100
Learn more about scoring.

We analyzed this package on Apr 6, 2020, and provided a score, details, and suggestions below. Analysis was completed with status completed using:

  • Dart: 2.7.1
  • pana: 0.13.6
  • Flutter: 1.12.13+hotfix.8

Dependencies

Package Constraint Resolved Available
Direct dependencies
Dart SDK >=2.0.0 <3.0.0
flutter 0.0.0
location_platform_interface ^1.0.0 1.0.0
location_web ^1.0.0 1.0.0
meta ^1.0.5 1.1.8
Transitive dependencies
charcode 1.1.3
collection 1.14.11 1.14.12
flutter_web_plugins 0.0.0
http_parser 3.1.4
js 0.6.1+1
path 1.6.4
plugin_platform_interface 1.0.2
sky_engine 0.0.99
source_span 1.7.0
string_scanner 1.0.5
term_glyph 1.1.0
typed_data 1.1.6
vector_math 2.0.8
Dev dependencies
async ^2.0.8
e2e ^0.2.4+1
flutter_test
mockito 3.0.0
test ^1.3.0